﻿using System;
using System.Windows.Forms;
using System.Drawing;

using BveTypes.ClassWrappers;

using AtsEx.PluginHost;
using AtsEx.PluginHost.Plugins;

namespace TrackPos
{
    [PluginType(PluginType.MapPlugin)]
    public class TrackPosController : AssemblyPluginBase
    {
        MyTrack myTrack;
        Form2 form = new Form2();
        TimeSpan ticsInterval = new TimeSpan();
        long tickelapsed = 0;
        UserVehicleLocationManager userVehicleLoc;
        TrackPlot trackPlot = new TrackPlot();

        public TrackPosController(PluginBuilder builder) : base(builder)
        {
            
            BveHacker.ScenarioCreated += OnScenarioCreated;

        }
        private void OnScenarioCreated(ScenarioCreatedEventArgs e)
        {
            myTrack = e.Scenario.Route.MyTrack;
            userVehicleLoc = e.Scenario.LocationManager;

            trackPlot.getTrackPos(e.Scenario.Route.MyTrack, e.Scenario.Route.DrawLimitLocation-9000);
            trackPlot.drawTrack();
            trackPlot.drawTrackVert();

            form.bmp_plane = trackPlot.drawVehiclePos();
            form.bmp_vert = trackPlot.drawVehiclePosVert();
            form.Show();
            
        }

        public override void Dispose()
        {
            BveHacker.ScenarioCreated -= OnScenarioCreated;

        }
        public override TickResult Tick(TimeSpan elapsed)
        {
            tickelapsed += elapsed.Ticks;
            if (tickelapsed > 1000 * TimeSpan.TicksPerMillisecond)
            {
                SlimDX.Vector3 userVehiclePos = myTrack.GetPosition(userVehicleLoc.Location,0);
                trackPlot.setVehiclePos(userVehiclePos[0], userVehiclePos[1], userVehiclePos[2], userVehicleLoc.Location, (((Curve)myTrack.Curves.GoToAndGetCurrent(userVehicleLoc.Location)).Curvature));
                form.bmp_plane = trackPlot.drawVehiclePos();
                form.bmp_vert = trackPlot.drawVehiclePosVert();
                form.Refresh();
                ticsInterval = elapsed;
                tickelapsed = 0;
            }
            return new MapPluginTickResult();
        }
    }
}
